var jQueryObjects = {};
function getJQueryObject(selector) {
	if(jQueryObjects[selector] == undefined || jQueryObjects[selector] == null) {
		return $(selector);
	}else{
		return jQueryObjects[selector];
	}
}

function chooseFileToUpload(inputFileId) {
	$('#' + inputFileId).click();
}

function getParameterByName(name) {
	var url = document.URL, count = url.indexOf(name);
	sub = url.substring(count);
	amper = sub.indexOf("&");

	if (amper == "-1") {
		var param = sub.split("=");
		return param[1];
	} else {
		var param = sub.substr(0, amper).split("=");
		return param[1];
	}
}

function initFileUploads() {
	var W3CDOM = (document.createElement && document.getElementsByTagName);
	
	if (W3CDOM) {
		// create fake div with element and button
		var fakeFileUpload = $('<div class="fakefile"></div>');
		var input = $('<input type="text" style="width:490px" readonly="readonly" name="fileUpload"/>');
		var span = $('<span class="btn margin-left-5">' + messages["button.browse"] + '...</span>');
		
		fakeFileUpload.append(input);
		fakeFileUpload.append(span);
		
		var fileInputElements = $('.fileinputs > input:file');

		fileInputElements.each(function(index, el) {
			// set attributes
			var element = $(el);
			element.addClass('file');
			element.attr('size', '57');

			// add fake div to elements parent
			var clone = fakeFileUpload.clone(true);
			element.get(0).relatedElement = clone.find('input')[0];
			element.parent().append(clone);

			element.change(function() {
				this.relatedElement.value = this.value;
			});
			element.mouseover(function() {
				var element = $('.fakefile > span');
				if (!element.hasClass('hovered')) {
					$('.fakefile > span').addClass('hovered');
				}
			});
			element.mouseout(function() {
				$('.fakefile > span').removeClass('hovered');
			});
		});
	}
}

$(function() {
	initFileUploads();
});

/*
 * This method is neccessary to close the gap between Java's SimpleDateFormat
 * and jQuery UI datepicker formatDate methods. Takes the SimpleDateFormat
 * string from the server and turns it into the expected jQueryUI formatDate.
 * Note: the jQueryUI formatDate only supports some of SimpleDateFormat
 * settings. Basically only Years, months, days, day of week
 */
function convertToJquiDateFormat(localFormatString) {

	// Year
	if (localFormatString.search(/y{3,}/g) >= 0) { /* YYYY */
		localFormatString = localFormatString.replace(/y{3,}/g, "yy");
	} else if (localFormatString.search(/y{2}/g) >= 0) { /* YY */
		localFormatString = localFormatString.replace(/y{2}/g, "y");
	}

	// Month
	if (localFormatString.search(/M{4,}/g) >= 0) { /* MMMM */
		localFormatString = localFormatString.replace(/M{4,}/g, "MM");
	} else if (localFormatString.search(/M{3}/g) >= 0) { /* MMM */
		localFormatString = localFormatString.replace(/M{3}/g, "M");
	} else if (localFormatString.search(/M{2}/g) >= 0) { /* MM */
		localFormatString = localFormatString.replace(/M{2}/g, "mm");
	} else if (localFormatString.search(/M{1}/g) >= 0) { /* M */
		localFormatString = localFormatString.replace(/M{1}/g, "m");
	}

	// Day
	if (localFormatString.search(/D{2,}/g) >= 0) { /* DD */
		localFormatString = localFormatString.replace(/D{2,}/g, "oo");
	} else if (localFormatString.search(/D{1}/g) >= 0) { /* D */
		localFormatString = localFormatString.replace(/D{1}/g, "o");
	}

	// Day of month
	if (localFormatString.search(/E{4,}/g) >= 0) { /* EEEE */
		localFormatString = localFormatString.replace(/E{4,}/g, "DD");
	} else if (localFormatString.search(/E{2,3}/g) >= 0) { /* EEE */
		localFormatString = localFormatString.replace(/E{2,3}/g, "D");
	}

	return localFormatString;
}

function initDatePicker(containerId) {
	$( "#" + containerId ).datepicker({
		closeText: 'Close',
		dateFormat: applicationDateFormat,
		showButtonPanel: true, 
		changeYear: true,
	    beforeShow: function( input ) {  
	    	 setTimeout(
	    		function() {  
	    		   var buttonPane = $( input ).datepicker( "widget" ).find( ".ui-datepicker-buttonpane" );  
	    		   var btn = $('<button class="ui-datepicker-clear ui-state-default ui-priority-primary ui-corner-all" type="button">Clear</button>');  
	    		   btn.unbind("click").bind("click", function () {  
	    		    	$.datepicker._clearDate( input );  
	    		  	});  
	    		   btn.appendTo( buttonPane );  
	    		   renderYear();
	    		}
	    		, 1 
	    	);  
	    },
	    onChangeMonthYear : function( input ) {  
			setTimeout(
				function() {  
					var buttonPane = $( input ).datepicker( "widget" ).find( ".ui-datepicker-buttonpane" );  
					var btn = $('<button class="ui-datepicker-clear ui-state-default ui-priority-primary ui-corner-all" type="button">Clear</button>');  
					btn.unbind("click").bind("click", function () {  
						$( "#" + containerId ).datepicker( "setDate", "" );
						$( "#" + containerId ).blur();
						$( "#" + containerId ).datepicker("hide");
	    		  	});  
					btn.appendTo( buttonPane );
					renderYear();
				}
				, 1 
			);  
	 	 }
	});
}

function renderYear() {
	var selector = 'select[class="ui-datepicker-year"]';
	
	$(selector).parent().remove(".yearLabel");
	
	var currentYear = $(selector).find('option:selected').text();
	var yearSelectionContent = '<div class="yearLabel"><div id="prevYearBtn" title="Prev" class="ui-datepicker-prev margin-top-20"><span class="ui-icon ui-icon-circle-triangle-w">Prev</span></div>' + currentYear + '<div class="ui-datepicker-next margin-top-20" title="Next" id="nextYearBtn"><span class="ui-icon ui-icon-circle-triangle-e">Next</span></div></div>';
	
	$(selector).after(yearSelectionContent);
	
	$(selector).parent().find("#prevYearBtn").click(function(){
		var year = parseInt($(selector).find('option:selected').text());
		$(selector).val(year - 1);
		$(selector).trigger('change');
	});
	
	$(selector).parent().find("#nextYearBtn").click(function(){
		var year = parseInt($(selector).find('option:selected').text());
		$(selector).val(year +1 );
		$(selector).trigger('change');
	});
}

function initAutoCompleteUsers() {
	$("#userName").autocomplete({
		focus: function(event, ui) {
			$('.ui-autocomplete').find('li >a').each(function() {
				var $this = $(this);
				if($this.text() == ui.item.label){
					$this.parent().addClass("ui-menu-item-hover");
					$this.removeClass('ui-state-focus');
					$this.addClass('white');
				} else {
					$this.parent().removeClass("ui-menu-item-hover");
					$this.removeClass('white');
				}
			});
			event.preventDefault();
		},
		select: function(event, ui) {
			$("#userName").val(ui.item.label);
			$("#userLogin").val(ui.item.value);
			updateFilterHeader();
			event.preventDefault();
		},
		source: function(request, response) {
			$.ajax({
				url: "getUsersTerms.htm",
				dataType: "json",
				data: request,
				success: function (data) {
					if(response.error != undefined) {
	            		showHeaderErrorNotification(messages["user.search.error.text"]);
	            	}else if (data.terms != undefined){
	            		response(data.terms);
	            	}else{
	            		showHeaderErrorNotification(messages["user.search.error.text"]);
	            	}
	            },
	            error: function () {
	                response([]); // send no results to the widget.
	                showHeaderErrorNotification(messages["user.search.error.text"]);
	            }
			});
		},
		open: function() {
			$(".ui-menu").width(476);
		}
	})
}