function getTimeStr() {
	var now = new Date();
	return ((now.getHours()<10)?"0":"")+now.getHours() 
		+ ":" + ((now.getMinutes()<10)?"0":"")+now.getMinutes() 
		+ ":" + ((now.getSeconds()<10)?"0":"")+now.getSeconds() 
		+ " - ";
}

function showHeaderErrorNotification(message) {
	hideLoadingPopup();
	if (null !== message && undefined !== message && '' !== message) {
		$("#error-text").html(getTimeStr() + message);
	} else {
		$("#error-text").html(getTimeStr());
	}
	$("#headerErrorNotification").show();
	$(window).scrollTop($('#headerErrorNotification').offset().top);
	$("#headerErrorNotification").unbind('click').click(function () {
		$("#headerErrorNotification").hide();
	});
}

function hideHeaderErrorNotification() {
	$("#headerErrorNotification").hide();
}

function showHeaderSuccessNotification(message) {
	$("#success-text").html(getTimeStr() + message);
	$("#headerSuccessNotification").show();
	$(window).scrollTop($('#headerSuccessNotification').offset().top);
	$("#headerSuccessNotification").unbind('click').click(function () {
		$("#headerSuccessNotification").hide();
	});
}

function showHeaderWarningNotification(message) {
	$("#warning-text").html(getTimeStr() + message);
	$("#headerWarningNotification").show();
	$(window).scrollTop($('#headerWarningNotification').offset().top);
	$("#headerWarningNotification").unbind('click').click(function () {
		$("#headerWarningNotification").hide();
	});
}

function hideHeaderSuccessNotification() {
	$("#headerSuccessNotification").hide();
}

function showErrorPopup(popupTitle, popupMessage) {
	$('#popup-error').attr('title', popupTitle);
	$('#error-message-container').html(popupMessage);
	$('#popup-error').dialog({
		resizable: false,
		height: "auto",
		modal: true,
		title: popupTitle
	});
	$('#error-ok').click(function() {
		$('#popup-error').dialog('close');
	});
}

function showScrollableErrorPopup(popupTitle, popupMessage) {
	$('#popup-error-scrollable').attr('title', popupTitle);
	$('#error-message-container-scrollable').html(popupMessage);
	$('#error-message-container-scrollable').css({"max-height": '200px', 'overflow-y' : "auto"});
	$('#popup-error-scrollable').dialog({
		resizable: false,
		height: "auto",
		width: 500,
		modal: true,
		title: popupTitle
	});
	$('#error-ok-scrollable').click(function() {
		$('#popup-error-scrollable').dialog('close');
	});
}

function showWarningPopup(popupTitle, popupMessage) {
	$('#popup-error').attr('title', popupTitle);
	$('#error-message-container').html(popupMessage);
	$('#popup-error').dialog({
		resizable: false,
		height: "auto",
		width: 500,
		modal: true,
		title: popupTitle
	});
	$('#error-ok').click(function() {
		$('#popup-error').dialog('close');
	});
}

function showConfirmationPopup(popupTitle, popupMessage, functionToCallOnConfirm, params) {
	$('#popup-confirm').attr('title', popupTitle);
	$('#confirm-message-container').html(popupMessage);
	
	$('#popup-confirm').dialog({
		resizable: false,
		height: "auto",
		modal: true,
		title: popupTitle
	});
	$('#confirm-cancel').unbind('click').click(function() {
		hideLoadingPopup();
		$('#popup-confirm').dialog('close');
	});
	$('#confirm-yes').unbind('click').click(function() {
		$('#popup-confirm').dialog('close');
		functionToCallOnConfirm(params);
	});
}

function showInformationPopup(popupTitle, popupMessage, popupHeader) {
	$('#popup-inform').attr('title', popupTitle);
	$('#inform-message-container').html(popupMessage);
	$('#inform-header-container').html(popupHeader);
	$('#popup-inform').dialog({
		resizable: false,
		height: "auto",
		modal: true,
		width: "auto",
		title: popupTitle
	});
	$('#inform-cancel').unbind('click').click(function() {
		$('#popup-inform').dialog('close');
	});
	
}

function hideProgressPopup(timerId) {
	if(timerId != undefined && timerId != null){
		window.clearInterval(timerId);
	}
	$('#popup-progress-bar').dialog('close');
}

function callProgressFunction(progressCheckURL, timerId, callBackFunction) {
	
	$.ajax({
		  url: progressCheckURL,
		  type: "GET",
		  dataType:'json',
		  async: false,
		  cache: false,
		  success: function(response){
			  if(response.error){
				  hideProgressPopup(timerId);
				  showHeaderErrorNotification(response.error);
			  }else{
				  $( "#progressbar" ).progressbar({value: response.progressValue });
				  $( "#progressMessage" ).html(response.progressMessage);
				  
				  if(response.progressValue == 100) {
					  hideProgressPopup(timerId);
					  callBackFunction(response);
				  }
			  }
		  },
		  error: function() {
			  hideProgressPopup(timerId);
			  showHeaderErrorNotification();
		  },
		  statusCode: {
			500: function() {
				hideProgressPopup(timerId);
				showHeaderErrorNotification();
			},
			404: function() {
				hideProgressPopup(timerId);
				showHeaderErrorNotification();
			}
		  }
	  
		});
}

function checkProgressByToken(token, timerId) {
	$.ajax({
		  url: 'getProgressStatus.htm?token=' + token,
		  type: "GET",
		  dataType:'json',
		  async: false,
		  cache: false,
		  success: function(response){
			  if(response.error){
				  hideLoadingPopup(timerId);
				  showHeaderErrorNotification(response.error);
			  }else{
				  if(response.progressValue == 100) {
					  hideLoadingPopup(timerId);
				  }
			  }
		  },
		  error: function() {
			  hideLoadingPopup(timerId);
			  showHeaderErrorNotification();
		  },
		  statusCode: {
			500: function() {
				hideLoadingPopup(timerId);
				showHeaderErrorNotification();
			},
			404: function() {
				hideLoadingPopup(timerId);
				showHeaderErrorNotification();
			}
		  }
		});
}

function showProgressPopup(popupTitle, progressCheckURL, progressCallURL, callBackFunction) {
	$('#popup-progress-bar').attr('title', popupTitle);
	
	$('#popup-progress-bar').dialog({
		resizable: false,
		height: "auto",
		modal: true,
		title: popupTitle
	});  
	$( "#progressActions" ).hide();
	$( "#progressbar" ).progressbar({value: 0 });
	$( "#progressMessage" ).html("");
	
	$.ajax({
		  url: progressCallURL,
		  async: true,
		  type: "GET"	});
	
	
	var timerId = setInterval(
		function() {
			callProgressFunction(progressCheckURL, timerId, callBackFunction);
		},
		200
	);
}


function getProgressToken(getTokenURL, callbackFunction) {
	$.ajax({
		  url: getTokenURL,
		  type: "GET",
		  dataType:'json',
		  async: false,
		  cache: false,
		  success: function(response){
			  if(response.error){
				  hideLoadingPopup();
				  showHeaderErrorNotification(response.error);
			  }else{
				  var timerId = setInterval(
	        				function() {
	        					checkProgressByToken(response.token, timerId);
	        				},
	        				200
	        			);
				  callbackFunction(response.token);
			  }
		  },
		  error: function() {
			  hideLoadingPopup();
			  showHeaderErrorNotification();
		  },
		  statusCode: {
			500: function() {
				hideLoadingPopup();
				showHeaderErrorNotification();
			},
			404: function() {
				hideLoadingPopup();
				showHeaderErrorNotification();
			}
		  }
		});
	return false;
}

function showLoadingPopup() {
	$('#popup-loading').dialog({
		resizable: false,
		height: 65,
		width: 100,
		modal: true,
		dialogClass: "no-title"
	});
}

function hideLoadingPopup(timerId) {
	if (!$('#popup-loading').hasClass('ui-dialog-content')) {
		return;
	}
	
	if(timerId != undefined && timerId != null){
		window.clearInterval(timerId);
	}
	
	$('#popup-loading').dialog('close');
}