var sessionTimeoutTicker = null;
var sessionTimeoutTickerSessionTimeout = null;
var sessionTimedOut = false;

function startSessionTimeoutTimer(sessionTimeoutInSeconds, messageParam){
	
	if (sessionTimeoutInSeconds == null) {
		return;
	}
	
	timeoutMessage = messageParam;
	timeoutInSeconds = sessionTimeoutInSeconds;
	
	methodSignature = "showSessionTimeoutPopup("+sessionTimeoutInSeconds*0.2+",'"+messageParam+"')";
	sessionTimeoutTickerSessionTimeout = setInterval("setSessionTimedOut()", sessionTimeoutInSeconds*1000);
	sessionTimeoutTicker = setInterval(methodSignature, sessionTimeoutInSeconds*1000*0.8);
	
}

function updateSessionTimeoutTimer(){

	var timeoutPopupTitle = $("#session-timeout-popup-title");
	var timeoutPopupTimeout = $("#session-timeout-popup-timeout");
	
	if (timeoutPopupTimeout == null || timeoutPopupTitle == null){
		return;
	}
	
	var timeoutPopupTimeoutHtml = timeoutPopupTimeout.html();
	var timeoutPopupTitleHtml = timeoutPopupTitle.html();
	if(timeoutPopupTimeoutHtml == undefined || timeoutPopupTitleHtml == undefined){
		return;
	}
	
	clearSessionTimeoutTimer();
	startSessionTimeoutTimer($.trim(timeoutPopupTimeoutHtml), $.trim(timeoutPopupTitleHtml));
	
}

function clearSessionTimeoutTimer(){
	clearInterval(sessionTimeoutTicker);
	clearInterval(sessionTimeoutTickerSessionTimeout);
}

function showSessionTimeoutPopup(sessionTimeoutInSeconds, message){

	timeoutInMinutes = Math.ceil(sessionTimeoutInSeconds/60);
	
	$('#session-timeout-popup-ok').click(function (event) {
		
		if (sessionTimedOut == true) { 
		
			window.location = "home.htm";

		} else {

			clearSessionTimeoutTimer();
			updateSessionTimeoutTimer(sessionTimeoutInSeconds);
			$('#session-timeout-popup').dialog('close');
			return false;

		}
		
	});
		
	$('#session-timeout-popup-minutes').html(timeoutInMinutes);
	
	var date = new Date(new Date().getTime() + timeoutInMinutes * 60000);
	
	$('#session-timeout-popup-time').html(date.toTimeString().substring(0,5));
	$('#session-timeout-popup').dialog({
		resizable: false,
		height: 200,
		modal: true,
		title: message
	});
	
}

function setSessionTimedOut(){

	sessionTimedOut = true;
	
}

jQuery(document).ready(function(){
	
	var timeoutPopupTitle = $("#session-timeout-popup-title");
	var timeoutPopupTimeout = $("#session-timeout-popup-timeout");
	
	if (timeoutPopupTimeout == null || timeoutPopupTitle == null){
		return;
	}
	
	var timeoutPopupTimeoutHtml = timeoutPopupTimeout.html();
	var timeoutPopupTitleHtml = timeoutPopupTitle.html();
	if(timeoutPopupTimeoutHtml == undefined || timeoutPopupTitleHtml == undefined){
		return;
	}
	
	startSessionTimeoutTimer($.trim(timeoutPopupTimeoutHtml), $.trim(timeoutPopupTitleHtml));
});

jQuery(document).ajaxComplete(function(event, xhr, settings) {
	
	if (xhr.responseText.indexOf("<title>Mock Login Form</title>") > 0){
		window.location = "home.htm";
		return false;
	}
			
	if (xhr.responseText.indexOf("ECAS password")>0 && xhr.responseText.indexOf("/cas/")>0){
		window.location = "home.htm";
		return false;
	}
	
	if(xhr.status == 210){
		window.location = "maintenance.htm";
	}
	
	var url = settings["url"];
	handleAutoSaveRequest(url);
});

// Method to handle autosave functionality for metadata file wizard. If request is in autoSave mode, 
// don't reset session timeout timer.
function handleAutoSaveRequest(url) {

	// If request is not in autoSave mode, clear session timeout timer
	if(typeof isAutoSaveRequest === "undefined" || !isAutoSaveRequest) {
		updateSessionTimeoutTimer();
		refreshTooltipsHandlers();
	} 
	
	// If the invoke of ajaxComplete was in last request of the chain of save metadata file to database request
	// change autosave request mode to false. Next of request's will be reset session timout timer.
	else if(url.indexOf("saveMetadataFileFromModelToDatabase.htm") != -1) {
		isAutoSaveRequest = false;
	}
}